﻿# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['3','3.2','3.2.3']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["checkresult4"] = "failed"
    
    tmp_vars["systemvalue1"] = ''
    tmp_vars["systemvalue2"] = ''
    tmp_vars["systemvalue3"] = ''
    tmp_vars["systemvalue4"] = ''
    ret_code = -1
    
    cur_basedir = runcontext.get_extra_var('MYSQL_BASEDIR')
    cur_plugin_dir = runcontext.get_extra_var('MYSQL_PLUGINDIR')

    
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','basedir')
        runcontext.log_debug("tmp1: %s" % tmp)
        if tmp != None:
            cur_basedir = tmp['value']

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--basedir=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        cur_basedir = matchs[-1]

    cur_basedir = runcontext.replace_inject_characters(cur_basedir)
    cur_plugin_dir = os.path.join(cur_basedir,"lib",'plugin')
    #find plugin_dir
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','plugin_dir')
        runcontext.log_debug("tmp2: %s" % tmp)
        if tmp != None:
            cur_plugin_dir = tmp['value']

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--plugin-dir=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        cur_plugin_dir = matchs[-1]
    
    cur_plugin_dir = runcontext.replace_inject_characters(cur_plugin_dir)

    #start shell part
    if cur_basedir != '':
        tmp_vars["scancommand1"] = "access=$(stat -L --format=\"%s\" %s);user=$(stat -L --format=\"%s\" %s);group=$(stat -L --format=\"%s\" %s);if (((0$access & 0077) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"%s $user:$group $access\";fi" % ('%a',cur_basedir,'%U',cur_basedir,'%G',cur_basedir,cur_basedir)
        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
        arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
        runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
        runcontext.sleep()
        if arc1 != 0:
            return (-2, "Failed to invoke module: %s."%astdout1)

        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        runcontext.log_debug_json(resultjson1)
        match1_found = re.match("^$",astdout1)
        if match1_found == None:
            tmp_vars["systemvalue1"] = astdout1
        else:
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["systemvalue1"] = astdout1

        runcontext.sleep()
        tmp_vars["scancommand2"] = "count=0;files=$(ls -ld %s/bin/mysql* | awk '{print $9}');for file in $files;do access=$(stat -L --format=%s $file);user=$(stat -L --format=%s $file);group=$(stat -L --format=%s $file);if (((0$access & 0277) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then count=$[count+1];if [ \"$count\" -gt \"100\" ]; then break;else echo \"$file $user:$group $access\";fi;fi;done;if [ \"$count\" -gt \"100\" ]; then echo \"Message length is more than 100!For more infomation manually execute the check policy.\";fi;" % (cur_basedir,'%a','%U','%G')
        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
        arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
        runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
        runcontext.sleep()
        if arc2 != 0:
            return (-2, "Failed to invoke module: %s."%astdout2) 
            
        resultjson2 = json.loads(astdout2)
        astdout2 = resultjson2["stdout"]
        runcontext.log_debug_json(resultjson2)
        match2_found = re.match("^$",astdout2)
        if match2_found == None:
            tmp_vars["systemvalue2"] = astdout2
        else:
            tmp_vars["checkresult2"] = "pass"
            tmp_vars["systemvalue2"] = astdout2
            
        runcontext.sleep()
        tmp_vars["scancommand3"] = "access=$(stat -L --format=\"%s\" /etc/init.d/mysql);user=$(stat -L --format=\"%s\" /etc/init.d/mysql);group=$(stat -L --format=\"%s\" /etc/init.d/mysql);if (( (0$access & 0277) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"/etc/init.d/mysql $user:$group $access\";fi" % ('%a','%U','%G')
        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
        arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
        runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)
        runcontext.sleep()
        if arc3 != 0:
            return (-2, "Failed to invoke module: %s."%astdout3) 
            
        resultjson3 = json.loads(astdout3)
        astdout3 = resultjson3["stdout"]
        runcontext.log_debug_json(resultjson3)
        match3_found = re.match("^$",astdout3)
        if match3_found == None:
            tmp_vars["systemvalue3"] = astdout3
        else:
            tmp_vars["checkresult3"] = "pass"
            tmp_vars["systemvalue3"] = astdout3

    if cur_plugin_dir != '':
        runcontext.sleep()
        tmp_vars["scancommand4"] = r"find -L %s -name 'libmysql*' \( -perm /277 \)" % (cur_plugin_dir)
        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand4"])
        arc4,astdout4,astderr4=runcontext.invoke_module(module,ansible_params)
        runcontext.log_debug_invoke_result(arc4,astdout4,astderr4)
        runcontext.sleep()
        if arc4 != 0:
            return (-2, "Failed to invoke module: %s."%astdout4) 

        resultjson4 = json.loads(astdout4)
        astdout4 = resultjson4["stdout"]
        runcontext.log_debug_json(resultjson4)
        match4_found = re.match("^$",astdout4)
        if match4_found == None:
            tmp_vars["systemvalue4"] = astdout4
        else:
            tmp_vars["checkresult4"] = "pass"
            tmp_vars["systemvalue4"] = astdout4

    if tmp_vars["checkresult4"] == 'pass' and tmp_vars["checkresult3"] == 'pass' and tmp_vars["checkresult2"] == 'pass' and tmp_vars["checkresult1"] == 'pass':
        tmp_vars["policyresult"]="pass"
        ret_code = 0


    rc,out = curtemplate.render(runcontext.get_template_file('r_3_2_3.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
