﻿# -*- coding: UTF-8 -*-

def get_tags():
    return ['3', '3.2', '3.2.9']


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = 'failed'
    tmp_vars["checkresult1"] = "failed"

    local_infile_value = 'ON'
    cur_local_infile = 'local_infile = ON'

    # find option
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld', 'log_slave_updates')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            local_infile_value = tmp['value']
            cur_local_infile = var_mysql_parser.pprint_option(tmp)
    if local_infile_value.lower() in ['on', '1', 'true']:
        ret_code = 0
        tmp_vars["policyresult"] = 'pass'
        tmp_vars["checkresult1"] = "pass"

    # set systemvalue
    tmp_vars["systemvalue1"] = cur_local_infile

    rc, out = curtemplate.render(runcontext.get_template_file('r_3_2_9.j2'),
                                 **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)
    return ret_code, out
