﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.10']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = 'failed'
    tmp_vars["checkresult1"] = "failed"
    
    sql_mode_value = ''
    cur_sql_mode = ''

    #find option
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','sql_mode')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            sql_mode_value = tmp['value']
            cur_sql_mode = var_mysql_parser.pprint_option(tmp)
            
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--sql-mode=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        sql_mode_value = matchs[-1]
        cur_sql_mode = '--sql-mode=%s' % sql_mode_value

    if 'strict_all_tables' in sql_mode_value.lower():
        ret_code = 0
        tmp_vars["policyresult"] = 'pass'
        tmp_vars["checkresult1"] = "pass"

    #set systemvalue
    tmp_vars["systemvalue1"] = cur_sql_mode

    rc,out = curtemplate.render(runcontext.get_template_file('s_2_2_10.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
