﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.1','2.1.10']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    ret_code = 0
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"

    cur_skip_symbolic_links = ''
    sug_skip_symbolic_links = '--skip-symbolic-links'
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--skip-symbolic-links')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        cur_skip_symbolic_links = sug_skip_symbolic_links

    if cur_skip_symbolic_links == '':
        ret_code = -1
    else:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"

    tmp_vars["systemvalue1"] = cur_skip_symbolic_links
    tmp_vars["suggestvalue1"] = sug_skip_symbolic_links

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_1_10.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
