﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.1','2.1.11']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    ret_code = 0
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"

    cur_skip_grant_tables_value = ''
    cur_skip_grant_tables = ''
    
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','skip_grant_tables')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            cur_skip_grant_tables_value = tmp['value']
            cur_skip_grant_tables = var_mysql_parser.pprint_option(tmp)
            if cur_skip_grant_tables_value == '':
                cur_skip_grant_tables = var_mysql_parser.pprint_option(tmp).replace("=","").strip()
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--skip-grant-tables')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        cur_skip_grant_tables_value = matchs[0]
        cur_skip_grant_tables = matchs[0]
        
    cur_skip_grant_tables_value = cur_skip_grant_tables_value.lower().strip()
    if cur_skip_grant_tables_value not in ['true','--skip-grant-tables','--skip_grant_tables']:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
    else:
        ret_code = -1

    tmp_vars["systemvalue1"] = cur_skip_grant_tables

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_1_11.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
