﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.1','2.1.13']


def run_task(runcontext):
    rc,out = run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    
    tmp_vars["systemvalue1"] = ''

    ret_code = -1
    
    cur_log_raw_value = 'OFF'
    cur_log_raw = ''
    
    
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','log_raw')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            cur_log_raw_value = tmp['value']
            cur_log_raw = var_mysql_parser.pprint_option(tmp)
            cur_log_raw = cur_log_raw.strip().strip('=').strip()
            if cur_log_raw in ['log-raw','log_raw']:
                cur_log_raw_value = cur_log_raw

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--log-raw)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        cur_log_raw_value = matchs[0]
        cur_log_raw = '%s' % cur_log_raw_value
    
    if cur_log_raw_value.lower() in ['off','']:
        tmp_vars["checkresult1"] = 'pass'
        tmp_vars["policyresult"] = "pass"
        ret_code = 0

    tmp_vars["systemvalue1"] = cur_log_raw


    rc,out = curtemplate.render(runcontext.get_template_file('r_2_1_13.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
