﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.12']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    secure_file_priv = ''
    cur_secure_file_priv = ''
    
    #find in cnf file
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','secure_file_priv')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            secure_file_priv = tmp['value']
            cur_secure_file_priv = 'secure_file_priv = %s' % secure_file_priv

    #find in command line
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--secure-file-priv)(=)(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        secure_file_priv = matchs[0][2]
        cur_secure_file_priv = '%s=%s' % (matchs[0][0],matchs[0][2])
    
    secure_file_priv = str(secure_file_priv).strip()
    tmp_vars = {}
    if secure_file_priv == '':
        tmp_vars["checkresult1"] = "failed"
    else:
        tmp_vars["checkresult1"] = "pass"

    tmp_vars["systemvalue1"] = cur_secure_file_priv

    ret_code = -1
    tmp_vars["policyresult"]="failed"
    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"]="pass"

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_12.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
