﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.13']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    relay_value = 'FILE'
    master_value = 'FILE'
    cur_relay = 'relay_log_info_repository = FILE'
    
    cur_master = 'master_info_repository = FILE'

    #find in cnf file
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','relay_log_info_repository')
        runcontext.log_debug("tmp1: %s" % tmp)
        if tmp != None:
            relay_value = tmp['value']
            cur_relay = var_mysql_parser.pprint_option(tmp)
            
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','master_info_repository')
        runcontext.log_debug("tmp2: %s" % tmp)
        if tmp != None:
            master_value = tmp['value']
            cur_master = var_mysql_parser.pprint_option(tmp)

    # find in command line
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern1 = re.compile(r'--relay-log-info-repository=(\S+)')
    matchs1 = pattern1.findall(var_mysql_cmd)
    pattern2 = re.compile(r'--master-info-repository=(\S+)')
    matchs2 = pattern2.findall(var_mysql_cmd)

    if len(matchs1) > 0:
        relay_value = matchs1[-1]
        cur_relay = '--relay-log-info-repository=%s' % relay_value
    elif len(matchs2) > 0:
        master_value = matchs2[-1]
        cur_master = '--master-info-repository=%s' % master_value
    
    rtmp = relay_value.strip().lower()
    tmp_vars = {}
    if rtmp != 'table':
        tmp_vars["checkresult1"] = "failed"
    else:
        tmp_vars["checkresult1"] = "pass"
        
    mtmp = master_value.strip().lower()
    if mtmp != 'table':
        tmp_vars["checkresult2"] = "failed"
    else:
        tmp_vars["checkresult2"] = "pass"

    tmp_vars["systemvalue1"] = cur_relay
    
    tmp_vars["systemvalue2"] = cur_master

    ret_code = -1
    tmp_vars["policyresult"]="failed"
    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"]="pass"

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_13.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
