﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.2','2.2.15']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()

    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["checkresult3"] = "failed"

    tmp_vars["scancommand1"] = "ps auxe | grep MYSQL_PWD | grep -v grep"
    tmp_vars["systemvalue1"] = ""
    
    tmp_vars["scancommand2"] = "env | grep -i ^MYSQL_PWD"
    tmp_vars["systemvalue2"] = ""
    
    tmp_vars["scancommand3"] = "pathlist=`sed -n -e 's/#.*//g' -e'/^$/!p' /etc/passwd | gawk -F: '$7~\"(/bin/bash)\" {print $6}'`; for  path in $pathlist;do  ret_g=`grep \"MYSQL_PWD\" $path/.{bashrc,profile,bash_profile} 2>/dev/null`; if [ -n \"$ret_g\" ]; then echo $ret_g; fi; done;"
    tmp_vars["systemvalue3"] = ""

    ret_code = -1
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    
    runcontext.log_debug(resultjson1)
    match1_found=re.match("^$",astdout1)

    
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]

    runcontext.log_debug(resultjson2)
    match2_found=re.match("^$",astdout2)


    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
    arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s."%astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]

    runcontext.log_debug(resultjson3)
    match3_found=re.match("^$",astdout3)

    if match1_found == None:
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = ''

    if match2_found == None:
        tmp_vars["systemvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = ''
        
    if match3_found == None:
        tmp_vars["systemvalue3"] = astdout3
    else:
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["systemvalue3"] = ''

    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult3"] == "pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_15.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)

    return ret_code,out
