﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.16']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    var_mysql_version = runcontext.get_extra_var('MYSQL_VERSION')
    if var_mysql_version < "5.6":
        tmp_vars = {}
        tmp_msg = "MySQL version is {0}".format(var_mysql_version)
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["checkresult4"] = "pass"
        tmp_vars["checkresult5"] = "pass"
        tmp_vars["checkresult6"] = "pass"
        tmp_vars["checkresult7"] = "pass"
        tmp_vars["checkresult8"] = "pass"
        tmp_vars["systemvalue1"] = tmp_msg
        tmp_vars["systemvalue2"] = tmp_msg
        tmp_vars["systemvalue3"] = tmp_msg
        tmp_vars["systemvalue4"] = tmp_msg
        tmp_vars["systemvalue5"] = tmp_msg
        tmp_vars["systemvalue6"] = tmp_msg
        tmp_vars["systemvalue7"] = tmp_msg
        tmp_vars["systemvalue8"] = tmp_msg
        tmp_vars["policyresult"] = "pass"
        ret_code = 0
    else:
        var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')

        cur_validate_value = ''
        cur_validate_length_value = '14'
        cur_validate_policy_value = 'MEDIUM'
        cur_validate_mixed_count_value = '1'
        cur_validate_number_count_value = '1'
        cur_validate_char_count_value = '1'
        cur_plugin_load_value = ''
        cur_plugin_load_add_value = ''

        def_validate = ''
        def_validate_length = 'validate_password_length = 14'
        def_validate_policy = 'validate_password_policy = MEDIUM'
        def_validate_mixed_count = 'validate_password_mixed_case_count = 1'
        def_validate_number_count = 'validate_password_number_count = 1'
        def_validate_char_count = 'validate_password_special_char_count = 1'
        def_plugin_load_value = ''
        def_plugin_load_add_value = ''

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','validate_password')
            runcontext.log_debug("tmp1: %s" % tmp)
            if tmp != None:
                cur_validate_value = tmp['value']
                def_validate = var_mysql_parser.pprint_option(tmp)

        var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
        pattern = re.compile(r'--validate-password=(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if matchs:
            cur_validate_value = matchs[-1]
            def_validate = '--validate-password=%s' % cur_validate_value

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','validate_password_length')
            runcontext.log_debug("tmp2: %s" % tmp)
            if tmp != None:
                cur_validate_length_value = tmp['value']
                def_validate_length = var_mysql_parser.pprint_option(tmp)
        pattern = re.compile(r'--validate-password-length=(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if matchs:
            cur_validate_length_value = matchs[-1]
            def_validate_length = '--validate-password-length=%s' % cur_validate_length_value

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','validate_password_policy')
            runcontext.log_debug("tmp3: %s" % tmp)
            if tmp != None:
                cur_validate_policy_value = tmp['value']
                def_validate_policy = var_mysql_parser.pprint_option(tmp)
        pattern = re.compile(r'--validate-password-policy=(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if matchs:
            cur_validate_policy_value = matchs[-1]
            def_validate_policy = '--validate-password-policy=%s' % cur_validate_policy_value

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','validate_password_mixed_case_count')
            runcontext.log_debug("tmp4: %s" % tmp)
            if tmp != None:
                cur_validate_mixed_count_value = tmp['value']
                def_validate_mixed_count = var_mysql_parser.pprint_option(tmp)
        pattern = re.compile(r'--validate-password-mixed-case-count=(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if matchs:
            cur_validate_mixed_count_value = matchs[-1]
            def_validate_mixed_count = '--validate-password-mixed-case-count=%s' % cur_validate_mixed_count_value

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','validate_password_number_count')
            runcontext.log_debug("tmp5: %s" % tmp)
            if tmp != None:
                cur_validate_number_count_value = tmp['value']
                def_validate_number_count = var_mysql_parser.pprint_option(tmp)
        pattern = re.compile(r'--validate-password-number-count=(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if matchs:
            cur_validate_number_count_value = matchs[-1]
            def_validate_number_count = '--validate-password-number-count=%s' % cur_validate_number_count_value


        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','validate_password_special_char_count')
            runcontext.log_debug("tmp6: %s" % tmp)
            if tmp != None:
                cur_validate_char_count_value = tmp['value']
                def_validate_char_count = var_mysql_parser.pprint_option(tmp)
        pattern = re.compile(r'--validate-password-special-char-count=(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if matchs:
            cur_validate_char_count_value = matchs[-1]
            def_validate_char_count = '--validate-password-number-count=%s' % cur_validate_char_count_value

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','plugin_load')
            runcontext.log_debug("tmp7: %s" % tmp)
            if tmp != None:
                cur_plugin_load_value = tmp['value']
                def_plugin_load_value = var_mysql_parser.pprint_option(tmp)

        pattern = re.compile(r'(--plugin-load)(=)(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if len(matchs) > 0:
            cur_plugin_load_value = matchs[0][2]
            def_plugin_load_value = '%s' % (''.join(matchs[0]))

        if var_mysql_parser != None:
            tmp = var_mysql_parser.get_option('mysqld','plugin_load_add')
            runcontext.log_debug("tmp8: %s" % tmp)
            if tmp != None:
                cur_plugin_load_add_value = tmp['value']
                def_plugin_load_add_value = var_mysql_parser.pprint_option(tmp)

        pattern = re.compile(r'(--plugin-load-add)(=)(\S+)')
        matchs = pattern.findall(var_mysql_cmd)
        if len(matchs) > 0:
            cur_plugin_load_add_value = matchs[0][2]
            def_plugin_load_add_value = '%s' % (''.join(matchs[0]))

        tmp_vars = {}
        #start judge result
        tmp1 = cur_validate_value.strip().lower()
        if tmp1 != 'force_plus_permanent':
            tmp_vars["checkresult1"] = "failed"
        else:
            tmp_vars["checkresult1"] = "pass"


        tmp2 = cur_validate_length_value.strip()
        tmp_vars["checkresult2"] = "failed"
        if tmp2.isdigit():
            if int(tmp2) >= 14:
                tmp_vars["checkresult2"] = "pass"

        tmp3 = cur_validate_policy_value.strip().lower()
        if tmp3 == "medium" or tmp3 == "strong":
            tmp_vars["checkresult3"] = "pass"
        else:
            tmp_vars["checkresult3"] = "failed"

        tmp4 = cur_validate_mixed_count_value.strip()
        tmp_vars["checkresult4"] = "failed"
        if tmp4.isdigit():
            if int(tmp4) >= 1:
                tmp_vars["checkresult4"] = "pass"

        tmp5 = cur_validate_number_count_value.strip()
        tmp_vars["checkresult5"] = "failed"
        if tmp5.isdigit():
            if int(tmp5) >= 1:
                tmp_vars["checkresult5"] = "pass"

        tmp6 = cur_validate_char_count_value.strip()
        tmp_vars["checkresult6"] = "failed"
        if tmp6.isdigit():
            if int(tmp6) >= 1:
                tmp_vars["checkresult6"] = "pass"

        tmp7 = cur_plugin_load_value.strip('\"').strip().lower()
        if 'validate_password.so' in tmp7.strip(";").split(";"):
            tmp_vars["checkresult7"] = "pass"
        else:
            tmp_vars["checkresult7"] = "failed"

        tmp8 = cur_plugin_load_add_value.strip('\"').strip().lower()
        if 'validate_password.so' in tmp8.strip(";").split(";"):
            tmp_vars["checkresult8"] = "pass"
        else:
            tmp_vars["checkresult8"] = "failed"

        tmp_vars["systemvalue1"] = def_validate
        tmp_vars["systemvalue2"] = def_validate_length
        tmp_vars["systemvalue3"] = def_validate_policy
        tmp_vars["systemvalue4"] = def_validate_mixed_count
        tmp_vars["systemvalue5"] = def_validate_number_count
        tmp_vars["systemvalue6"] = def_validate_char_count
        tmp_vars["systemvalue7"] = def_plugin_load_value
        tmp_vars["systemvalue8"] = def_plugin_load_add_value

        ret_code = 0
        if (tmp_vars['checkresult8'] == 'pass' or tmp_vars['checkresult7'] == 'pass') and tmp_vars['checkresult6'] == 'pass' and tmp_vars['checkresult5'] == 'pass' and tmp_vars['checkresult4'] == 'pass' and tmp_vars['checkresult3'] == 'pass' and tmp_vars['checkresult2'] == 'pass' and tmp_vars['checkresult1'] == 'pass':
            tmp_vars['policyresult'] = 'pass'
        else:
            ret_code = -1
            tmp_vars['policyresult'] = 'failed'

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_16.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
