﻿# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['2','2.2','2.2.17']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["systemvalue1"] = ""
    tmp_vars["systemvalue2"] = ""
    ret_code = -1
    
    curtemplate=runcontext.get_template()
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    log_error_value = ''


    #find in cnf file
    cur_log_error = ''
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','log_error')
        runcontext.log_debug("tmp1: %s" % tmp)
        if tmp != None:
            log_error_value = tmp['value']
            cur_log_error = var_mysql_parser.pprint_option(tmp)

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--log-error)(=)(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        log_error_value = matchs[0][2]
        cur_log_error = '%s' % (''.join(matchs[0]))

    # get --basedir
    mysql_basedir = runcontext.get_extra_var('MYSQL_BASEDIR')
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','basedir')
        runcontext.log_debug("tmp2: %s" % tmp)
        if tmp != None:
            mysql_basedir = tmp['value']
            
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--basedir)(=)(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    
    if len(matchs) > 0:
        mysql_basedir = matchs[0][2]
    mysql_basedir = runcontext.replace_inject_characters(mysql_basedir)
    
    # get datadir
    mysql_datadir = runcontext.get_extra_var('MYSQL_DATADIR')
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','datadir')
        runcontext.log_debug("tmp3: %s" % tmp)
        if tmp != None:
            mysql_datadir = tmp['value']
            
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--datadir)(=)(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
   
    if len(matchs) > 0:
        mysql_datadir = matchs[0][2]    
    
    mysql_datadir = runcontext.replace_inject_characters(mysql_datadir)
        
    # log-error is file
    rtmp = ''
    if log_error_value != '':
        rtmp = log_error_value.strip()
        if not os.path.isabs(log_error_value):
            if not os.path.isabs(mysql_datadir):
                mysql_datadir = os.path.join(mysql_basedir,mysql_datadir)
            log_error_value = os.path.join(mysql_datadir,log_error_value)
    
    rtmp = log_error_value.strip()
    if len(rtmp) != 0:
        tmp_vars["checkresult1"] = "pass"
    
    if log_error_value != '':
        
        tmp_vars["scancommand2"] = r"df -h %s | grep -v '^Filesystem\s'" % log_error_value
        
        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
        arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
        runcontext.sleep()
        if arc2 != 0:
            return (-2, "Failed to invoke module: %s."%astdout2)
        resultjson2 = json.loads(astdout2)
        astdout2 = resultjson2["stdout"]

        runcontext.log_debug_json(resultjson2)
        match2_found = re.match(".+(/|/var|/usr)$",astdout2)
        tmp_vars["systemvalue2"] = astdout2
        if match2_found == None:
            tmp_vars["checkresult2"] = "pass"
        
    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0
        
    tmp_vars["systemvalue1"] = cur_log_error

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_17.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
