﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.18']

    
def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    log_warnings = '1'
    cur_log_warnings = 'log_warnings = 1'

    #find in cnf file
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','log_warnings')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            log_warnings = tmp['value']
            cur_log_warnings = var_mysql_parser.pprint_option(tmp)

    #find in command line
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--log-warnings=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        log_warnings = matchs[-1]
        cur_log_warnings = '--log-warnings=%s' % log_warnings
        
    log_warnings = log_warnings.strip()
    tmp_vars = {}
    if log_warnings != '2':
        tmp_vars["checkresult1"] = "failed"
    else:
        tmp_vars["checkresult1"] = "pass"

    tmp_vars["systemvalue1"] = cur_log_warnings

    ret_code = -1
    tmp_vars["policyresult"]="failed"
    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"]="pass"

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_18.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
