﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.7']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = 'failed'
    tmp_vars["checkresult1"] = "failed"
    
    secure_auth_value = ''
    cur_secure_auth = ''

    #find option
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','secure_auth')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            secure_auth_value = tmp['value']
            cur_secure_auth = var_mysql_parser.pprint_option(tmp)

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--secure-auth)(=?)(\S*)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        if matchs[0][1] == '':
            secure_auth_value = matchs[0][0]
            cur_secure_auth = matchs[0][0]
        else:
            secure_auth_value = matchs[0][2]
            cur_secure_auth = '%s=%s' % (matchs[0][0],matchs[0][2])

    #start judge
    if secure_auth_value.lower() in ['1','on','--secure-auth','--secure_auth']:
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["policyresult"] = "pass"

    #set systemvalue
    tmp_vars["systemvalue1"] = cur_secure_auth

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_7.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
