﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.4','2.4.1']


def run_task(runcontext):
    rc,out = run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    ret_code = 0
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    bind_address_value = '*'
    def_address_value = 'bind_address = *'
    
    
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','bind_address')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            bind_address_value = tmp['value']
            def_address_value = var_mysql_parser.pprint_option(tmp)
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--bind-address=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        bind_address_value = matchs[-1]
        def_address_value = '--bind-address=%s' % bind_address_value
        
    bind_address_value = bind_address_value.strip()
    if '*' in bind_address_value or '0.0.0.0' in bind_address_value or '::' in bind_address_value:
        ret_code = -1
    else:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"

    tmp_vars["systemvalue1"] = def_address_value

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_4_1.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
