﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.4','2.4.2']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()

    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    ret_code = 0

    port_value = '3306'
    def_port = 'port = 3306'

    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','port')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            port_value = tmp['value']
            def_port = var_mysql_parser.pprint_option(tmp)

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--port=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        port_value = matchs[-1]
        def_port = '--port=%s' % port_value
    
    port_value = port_value.strip()
    if port_value == '3306':
        ret_code = -1
    else:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
        
    tmp_vars["systemvalue1"] = def_port

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_4_2.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
