﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.4','2.4.7']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')

    cur_plugin_load_value = ''
    cur_plugin_load_add_value = ''
    cur_conn_control_value = 'FORCE_PLUS_PERMANENT'
    cur_conn_failed_login_atte_value = 'ON'
    cur_conn_failed_conn_thre_value = '3'
    cur_conn_min_conn_delay_value = '1000'
    cur_conn_max_conn_delay_value = '2147483647'
    
    cur_plugin_load = ''
    cur_plugin_load_add = ''
    cur_conn_control= 'connection_control = FORCE_PLUS_PERMANENT'
    cur_conn_failed_login_atte = 'connection_control_failed_login_attempts = ON'
    cur_conn_failed_conn_thre = 'connection_control_failed_connections_threshold = 3'
    cur_conn_min_conn_delay = 'connection_control_min_connection_delay = 1000'
    cur_conn_max_conn_delay = 'connection_control_max_connection_delay = 2147483647'

    # find plugin
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','plugin_load')
        runcontext.log_debug("tmp1: %s" % tmp)
        if tmp != None:
            cur_plugin_load_value = tmp['value']
            cur_plugin_load = var_mysql_parser.pprint_option(tmp)

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--plugin-load)(=)(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_plugin_load_value = matchs[0][2]
        cur_plugin_load = '%s' % (''.join(matchs[0]))

    # find plugin add
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld', 'plugin_load_add')
        runcontext.log_debug("tmp8: %s" % tmp)
        if tmp != None:
            cur_plugin_load_add_value = tmp['value']
            cur_plugin_load_add = var_mysql_parser.pprint_option(tmp)

    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'(--plugin-load-add)(=)(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_plugin_load_add_value = matchs[0][2]
        cur_plugin_load_add = '%s' % (''.join(matchs[0]))

    #find conn_control
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','connection_control')
        runcontext.log_debug("tmp2: %s" % tmp)
        if tmp != None:
            cur_conn_control_value = tmp['value']
            cur_conn_control = var_mysql_parser.pprint_option(tmp)
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--connection-control=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_conn_control_value = matchs[-1]
        cur_conn_control = '--connection-control=%s' % cur_conn_control_value
        
    #find control_failed_attemp
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','connection_control_failed_login_attempts')
        runcontext.log_debug("tmp:3 %s" % tmp)
        if tmp != None:
            cur_conn_failed_login_atte_value = tmp['value']
            cur_conn_failed_login_atte = var_mysql_parser.pprint_option(tmp)
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--connection-control-failed-login-attempts=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_conn_failed_login_atte_value = matchs[-1]
        cur_conn_failed_login_atte = '--connection-control-failed-login-attempts=%s' % cur_conn_failed_login_atte_value
        
        
    #find threshold
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','connection_control_failed_connections_threshold')
        runcontext.log_debug("tmp4: %s" % tmp)
        if tmp != None:
            cur_conn_failed_conn_thre_value = tmp['value']
            cur_conn_failed_conn_thre = var_mysql_parser.pprint_option(tmp)
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--connection-control-failed-connections-threshold=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_conn_failed_conn_thre_value = matchs[-1]
        cur_conn_failed_conn_thre = '--connection-control-failed-connections-threshold=%s' % cur_conn_failed_conn_thre_value
        
    #find delay
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','connection_control_min_connection_delay')
        runcontext.log_debug("tmp5: %s" % tmp)
        if tmp != None:
            cur_conn_min_conn_delay_value = tmp['value']
            cur_conn_min_conn_delay = var_mysql_parser.pprint_option(tmp)
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--connection-control-min-connection-delay=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_conn_min_conn_delay_value = matchs[-1]
        cur_conn_min_conn_delay = '--connection-control-min-connection-delay=%s' % cur_conn_min_conn_delay_value
        
    #find conn_dealy
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','connection-control-max-connection-delay')
        runcontext.log_debug("tmp6: %s" % tmp)
        if tmp != None:
            cur_conn_max_conn_delay_value = tmp['value']
            cur_conn_max_conn_delay = var_mysql_parser.pprint_option(tmp)
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--connection-control-max-connection-delay=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        cur_conn_max_conn_delay_value = matchs[-1]
        cur_conn_max_conn_delay = '--connection-control-max-connection-delay=%s' % cur_conn_max_conn_delay_value
        
    tmp_vars = {}
    #start judge result
    tmp1 = cur_plugin_load_value.strip().strip('\"').lower()
    if tmp1 != 'connection_control.so':
        tmp_vars["checkresult1"] = "failed"
    else:
        tmp_vars["checkresult1"] = "pass"
        

    tmp2 = cur_conn_control_value.strip().lower()
    if tmp2 != 'force_plus_permanent':
        tmp_vars["checkresult2"] = "failed"
    else:
        tmp_vars["checkresult2"] = "pass"
        
        
    tmp3 = cur_conn_failed_login_atte_value.strip().lower()
    if tmp3 == "force_plus_permanent":
        tmp_vars["checkresult3"] = "pass"
    else:
        tmp_vars["checkresult3"] = "failed"
        
    tmp4 = cur_conn_failed_conn_thre_value.strip()
    tmp_vars["checkresult4"] = "failed"
    if tmp4.isdigit():
        if tmp4 != '':
            tmp_vars["checkresult4"] = "pass"
        
    tmp5 = cur_conn_min_conn_delay_value.strip()
    tmp_vars["checkresult5"] = "failed"
    if tmp5.isdigit():
        if int(tmp5) >= 1000 and int(tmp5) < 2147483647:
            tmp_vars["checkresult5"] = "pass"
    
    tmp6 = cur_conn_max_conn_delay_value.strip()
    tmp_vars["checkresult6"] = "failed"
    if tmp6.isdigit():
        if int(tmp6) > 1000 and int(tmp6) <= 2147483647:
            tmp_vars["checkresult6"] = "pass"
        
    
    tmp_vars["checkresult7"] = "failed"
    if tmp5.isdigit() and tmp6.isdigit():
        if int(tmp5) < int(tmp6):
            tmp_vars["checkresult7"] = "pass"

    tmp8 = cur_plugin_load_add_value.strip().strip('\"').lower()
    if tmp8 != 'connection_control.so':
        tmp_vars["checkresult8"] = "failed"
    else:
        tmp_vars["checkresult8"] = "pass"
    
    tmp_vars["systemvalue1"] = cur_plugin_load
    tmp_vars["systemvalue2"] = cur_conn_control
    tmp_vars["systemvalue3"] = cur_conn_failed_login_atte
    tmp_vars["systemvalue4"] = cur_conn_failed_conn_thre
    tmp_vars["systemvalue5"] = cur_conn_min_conn_delay
    tmp_vars["systemvalue6"] = cur_conn_max_conn_delay
    tmp_vars["systemvalue7"] = cur_conn_min_conn_delay + ' ' + cur_conn_max_conn_delay
    tmp_vars["systemvalue8"] = cur_plugin_load_add

    
    ret_code = 0
    if tmp_vars['checkresult7'] == 'pass' and tmp_vars['checkresult6'] == 'pass' and tmp_vars['checkresult5'] == 'pass' and tmp_vars['checkresult4'] == 'pass' and tmp_vars['checkresult3'] == 'pass' and tmp_vars['checkresult2'] == 'pass' and (tmp_vars['checkresult1'] == 'pass' or tmp_vars['checkresult8'] == 'pass'):
        tmp_vars['policyresult'] = 'pass' 
    else:
        ret_code = -1
        tmp_vars['policyresult'] = 'failed'

    rc,out=curtemplate.render(runcontext.get_template_file('r_2_4_7.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
