﻿# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['3','3.1','3.1.2']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    ret_code = -1
    
    cur_expire_logs_days_value = 0
    cur_expire_logs_days = 'expire_logs_days = 0'

    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','expire_logs_days')
        runcontext.log_debug("tmp: %s" % tmp)
        if tmp != None:
            cur_expire_logs_days_value = tmp['value']
            cur_expire_logs_days = var_mysql_parser.pprint_option(tmp)
            
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--expire-logs-days=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)

    if len(matchs) > 0:
        cur_expire_logs_days_value = matchs[-1]
        cur_expire_logs_days = '--expire-logs-days=%s' % cur_expire_logs_days_value
    
    
    if cur_expire_logs_days_value != 0:
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["policyresult"] = "pass"
    
    tmp_vars["systemvalue1"] = cur_expire_logs_days

    rc,out = curtemplate.render(runcontext.get_template_file('r_3_1_2.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
