﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['3','3.2','3.2.6']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ''
    errCnfs = []

    ret_code = -1

    mysql_cnf_files = runcontext.get_parameter('cur_cnf_files')
    runcontext.log_debug(mysql_cnf_files)
    for cnf_file in mysql_cnf_files:
        cnf_file = runcontext.replace_inject_characters(cnf_file)
        tmp_vars["scancommand1"] = "access=$(stat -L --format=\"%s\" %s);user=$(stat -L --format=\"%s\" %s);group=$(stat -L --format=\"%s\" %s);if (((0$access & 0177) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"%s $user:$group $access\";fi" % ('%a',cnf_file,'%U',cnf_file,'%G',cnf_file,cnf_file)

        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
        arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
        runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
        runcontext.sleep()
        if arc1 != 0:
            return (-2, "Failed to invoke module: %s."%astdout1)

        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        runcontext.log_debug_json(resultjson1)
        match1_found=re.match("^$",astdout1)
        if match1_found == None:
            errCnfs.append(astdout1)

    if len(errCnfs) == 0:
        tmp_vars["policyresult"]="pass"
        tmp_vars["checkresult1"] = "pass"
        ret_code = 0

    tmp_vars["systemvalue1"] = '\n'.join(errCnfs)

    rc,out = curtemplate.render(runcontext.get_template_file('r_3_2_6.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
