﻿# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['3','3.2','3.2.8']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    var_mysql_parser = runcontext.get_parameter('_mysql_conf_parse')

    ssl_ca_value = ''
    ssl_cert_value = ''
    ssl_key_value = ''
    ssl_crl_value = ''
    
    #find ssl_ca
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','ssl_ca')
        runcontext.log_debug("tmp1: %s" % tmp)
        if tmp != None:
            ssl_ca_value = tmp['value']
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--ssl-ca=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        ssl_ca_value = matchs[-1]

    #find ssl_cert
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','ssl_cert')
        runcontext.log_debug("tmp2: %s" % tmp)
        if tmp != None:
            ssl_cert_value = tmp['value']
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--ssl-cert=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        ssl_cert_value = matchs[-1]
    
    #find ssl_key
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','ssl_key')
        runcontext.log_debug("tmp3: %s" % tmp)
        if tmp != None:
            ssl_key_value = tmp['value']
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--ssl-key=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        ssl_key_value = matchs[-1]

    #find ssl_crl
    if var_mysql_parser != None:
        tmp = var_mysql_parser.get_option('mysqld','ssl_crl')
        runcontext.log_debug("tmp4: %s" % tmp)
        if tmp != None:
            ssl_crl_value = tmp['value']
    
    var_mysql_cmd = runcontext.get_extra_var('MYSQL_COMMAND')
    pattern = re.compile(r'--ssl-crl=(\S+)')
    matchs = pattern.findall(var_mysql_cmd)
    if len(matchs) > 0:
        ssl_crl_value = matchs[-1]
    
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "pass"
    tmp_vars["checkresult2"] = "pass"
    tmp_vars["checkresult3"] = "pass"
    tmp_vars["checkresult4"] = "pass"
    
    tmp_vars["systemvalue1"] = ''
    tmp_vars["systemvalue2"] = ''
    tmp_vars["systemvalue3"] = ''
    tmp_vars["systemvalue4"] = ''
     
    tmp_vars["scancommand1"] = ''
    tmp_vars["scancommand2"] = ''
    tmp_vars["scancommand3"] = ''
    tmp_vars["scancommand4"] = ''

    #judge ssl_ca
    if ssl_ca_value != '':
        if os.path.exists(ssl_ca_value):
            tmp_vars["scancommand1"] = "access=$(stat -L --format=\"%s\" %s);user=$(stat -L --format=\"%s\" %s);group=$(stat -L --format=\"%s\" %s);if (((0$access & 0377) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"%s $user:$group $access\";fi" % ('%a',ssl_ca_value,'%U',ssl_ca_value,'%G',ssl_ca_value,ssl_ca_value)
            runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
            arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
            runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
            runcontext.sleep()
            if arc1 != 0:
                return (-2, "Failed to invoke module: %s."%astdout1)

            resultjson1 = json.loads(astdout1)
            astdout1 = resultjson1["stdout"]
            runcontext.log_debug_json(resultjson1)
            match1_found = re.match("^$",astdout1)
            if match1_found == None:
                tmp_vars["systemvalue1"] = astdout1
                tmp_vars["checkresult1"] = "failed"
            else:
                tmp_vars["checkresult1"] = "pass"
                tmp_vars["systemvalue1"] = astdout1   
        
    #judge ssl_cert
    if ssl_cert_value != '':
        if os.path.exists(ssl_cert_value):
            tmp_vars["scancommand2"] = "access=$(stat -L --format=\"%s\" %s);user=$(stat -L --format=\"%s\" %s);group=$(stat -L --format=\"%s\" %s);if (((0$access & 0377) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"%s $user:$group $access\";fi" % ('%a',ssl_cert_value,'%U',ssl_cert_value,'%G',ssl_cert_value,ssl_cert_value)
            runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
            arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
            runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
            runcontext.sleep()
            if arc2 != 0:
                return (-2, "Failed to invoke module: %s."%astdout2)

            resultjson2 = json.loads(astdout2)
            astdout2 = resultjson2["stdout"]
            runcontext.log_debug_json(resultjson2)
            match2_found = re.match("^$",astdout2)
            if match2_found == None:
                tmp_vars["systemvalue2"] = astdout2
                tmp_vars["checkresult2"] = "failed"
            else:
                tmp_vars["checkresult2"] = "pass"
                tmp_vars["systemvalue2"] = astdout2
        
    #judge ssl_key
    if ssl_key_value != '':
        if os.path.exists(ssl_key_value):
            tmp_vars["scancommand3"] = "access=$(stat -L --format=\"%s\" %s);user=$(stat -L --format=\"%s\" %s);group=$(stat -L --format=\"%s\" %s);if (((0$access & 0377) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"%s $user:$group $access\";fi" % ('%a',ssl_key_value,'%U',ssl_key_value,'%G',ssl_key_value,ssl_key_value)
            runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
            arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
            runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)
            runcontext.sleep()
            if arc3 != 0:
                return (-2, "Failed to invoke module: %s."%astdout3)

            resultjson3 = json.loads(astdout3)
            astdout3 = resultjson3["stdout"]
            runcontext.log_debug_json(resultjson3)
            match3_found = re.match("^$",astdout3)
            if match3_found == None:
                tmp_vars["systemvalue3"] = astdout3
                tmp_vars["checkresult3"] = "failed"
            else:
                tmp_vars["checkresult3"] = "pass"
                tmp_vars["systemvalue3"] = astdout3
            
    #judge ssl_crl
    if ssl_crl_value != '':
        if os.path.exists(ssl_crl_value):
            tmp_vars["scancommand4"] = "access=$(stat -L --format=\"%s\" %s);user=$(stat -L --format=\"%s\" %s);group=$(stat -L --format=\"%s\" %s);if (((0$access & 0377) != 0 )) || [ \"$user\" == 'root' ] || [ \"$group\" == 'root' ];then echo \"%s $user:$group $access\";fi" % ('%a',ssl_crl_value,'%U',ssl_crl_value,'%G',ssl_crl_value,ssl_crl_value)
            runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand4"])
            arc4,astdout4,astderr4=runcontext.invoke_module(module,ansible_params)
            runcontext.log_debug_invoke_result(arc4,astdout4,astderr4)
            runcontext.sleep()
            if arc4 != 0:
                return (-2, "Failed to invoke module: %s."%astdout4)

            resultjson4 = json.loads(astdout4)
            astdout4 = resultjson4["stdout"]
            runcontext.log_debug_json(resultjson4)
            match4_found = re.match("^$",astdout4)
            if match4_found == None:
                tmp_vars["systemvalue4"] = astdout4
                tmp_vars["checkresult4"] = "failed"
            else:
                tmp_vars["checkresult4"] = "pass"
                tmp_vars["systemvalue4"] = astdout4

    if tmp_vars['checkresult4'] == 'pass' and tmp_vars['checkresult3'] == 'pass' and tmp_vars['checkresult2'] == 'pass' and tmp_vars['checkresult1'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        tmp_vars['policyresult'] = 'failed'

    rc,out = curtemplate.render(runcontext.get_template_file('r_3_2_8.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
