﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.1','2.1.8']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    check_command1 = 'ls -a /usr/bin/msql2mysql  2>/dev/null;ls -a /usr/bin/mysql_config_editor  2>/dev/null;ls -a /usr/bin/mysql_find_rows  2>/dev/null;ls -a /usr/bin/mysql_waitpid  2>/dev/null;ls -a /usr/bin/mysqlaccess  2>/dev/null;ls -a /usr/bin/mysqlaccess.conf  2>/dev/null;ls -a /usr/bin/mysqlbinlog  2>/dev/null;ls -a /usr/bin/mysqlcheck  2>/dev/null;ls -a /usr/bin/mysqldump  2>/dev/null;ls -a /usr/bin/mysqlimport  2>/dev/null;ls -a /usr/bin/mysqlshow  2>/dev/null;ls -a /usr/bin/mysqlslap 2>/dev/null;'
    check_command2 = 'ls /usr/share/man/man1/*mysql* 2>/dev/null |grep -w -v mysql.1'
    mysql_home = runcontext.get_extra_var('MYSQL_BASEDIR')
    mysql_home = runcontext.replace_inject_characters(mysql_home)
    if len(mysql_home) > 0:
        check_command = check_command1.replace('/usr', mysql_home) + check_command2.replace('/usr/share',mysql_home)
    else:
        check_command = check_command1 + check_command2
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = check_command
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]

    runcontext.log_debug_json(resultjson1)
    match1_found=re.match("^$",astdout1)
    if match1_found == None:
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = ""

    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0

    rc,out = curtemplate.render(runcontext.get_template_file('s_2_1_8.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
